var todoValues = new Array(0);
var doneValues = new Array(0);
var numHigh = 0;
var numMedium = 0;
var numLow = 0;
var editValue=-1;
var editPriorityValue=-1;

// Execute the script on load
window.addEventListener('load',function(ev) {

	// add behavior to the flip button on the front side
	document.getElementById('flipfront').addEventListener('click',function(ev){
		flipWidget("back");
	}, false);

	// add behavior to the flip button on the front side
	document.getElementById('flipback').addEventListener('click',function(ev){
		flipWidget("front");
	}, false);

	// add behavior to the edit box to add items
	document.newtodoform.onsubmit = function(ev){
		return onAdd();
	};

	// add behavior to the edit box to edit items
	document.todoform.onsubmit = function(ev){
		return onEdit();
	};

	document.getElementById('widgetsize').onchange = function(ev) {
		onWidgetSizeChanged();
	};

	document.getElementById('fontsize').onchange = function(ev) {
		onFontSizeChanged();
	};

	init();

},false);

// Perform the flipping of the widget
function flipWidget(to)
{
  switch (to) {
    case "back":
      document.getElementById('frontview').style.display = "none";
      document.getElementById('configview').style.display = "block";
      break;
    case "front":
      document.getElementById('configview').style.display = "none";
      document.getElementById('frontview').style.display = "block";
      break;
    default:
      // do nothing
      break;
  }
}

function init() 
{
	document.newtodoform.item.focus();
	load();
}

function onAdd()
{
	todoValues.splice(numHigh, 0, document.newtodoform.item.value);
	document.newtodoform.item.value = "";
	document.newtodoform.item.focus();
	++numMedium;

	display(-1, -1);
	return false;
}

function onEdit()
{
	if (editValue >= 0) {
		todoValues[editValue] = document.todoform.edittodo.value;
		document.newtodoform.item.focus();

		display(-1, -1);
	}
	return false;
}

function cancelEdit()
{
	display(-1, -1);
}

function todoTools(i) 
{
	return  " <img onclick=\"return editTodo("+i+")\" title=\"edit\" width=12 height=12 src=\"images/edit.png\"/>"+
		" <img onclick=\"return deleteTodo("+i+")\" title=\"delete\" width=12 height=12 src=\"images/delete.png\"/>"+
		((i>0)?
			" <img onclick=\"return upTodo("+i+")\" title=\"move up\" width=12 height=12 src=\"images/up.png\"/>":
			"")+
		((i<todoValues.length-1)?
			" <img onclick=\"return downTodo("+i+")\" title=\"move down\" width=12 height=12 src=\"images/down.png\"/>":
			"");
}

function createTodo(i, todoValue)
{
	priority = priorityName(i);
	if (editValue == i) {
		return "<input type=\"checkbox\" name=\"todo_"+i+"\" onclick=\"check(this, "+i+")\"/>" +
			"<img class=\""+priority+"\"/>" +
			"<input class=\"smalleditbox\" name=\"edittodo\" onblur=\"cancelEdit()\"/>"+todoTools(i)+"<br/>";
	}
	else if (editPriorityValue == i) {
		return "<input type=\"checkbox\" name=\"todo_"+i+"\" onclick=\"check(this, "+i+")\"/>" +
			"<img class=\"high\" onclick=\"toHighPriority("+i+");\" />" +
			"<img class=\"medium\" onclick=\"toMediumPriority("+i+");\" />" +
			"<img class=\"low\" onclick=\"toLowPriority("+i+");\" />" +
			"<span class=\"todo"+priority+"\" onclick=\"editTodo("+i+")\">" +
			escapeHtml(todoValue)+"</span>"+todoTools(i)+"<br/>";
	}
	else {
		return "<input type=\"checkbox\" name=\"todo_"+i+"\" onclick=\"check(this, "+i+")\"/>" +
			"<img class=\""+priority+"\" onclick=\"changePriority("+i+");\" />" +
			"<span class=\"todo"+priority+"\" onclick=\"editTodo("+i+")\">" +
			escapeHtml(todoValue)+"</span>"+todoTools(i)+"<br/>";
	}
}

function changePriority(i)
{
	display(-1, i);
}

function toHighPriority(i)
{
	var v = todoValues[i];
	if (i < numHigh) {
	}
	else if (i < numHigh+numMedium) {
		todoValues.splice(i, 1);
		todoValues.splice(numHigh, 0, v);
		++numHigh;
		--numMedium;
	}
	else {
		todoValues.splice(i, 1);
		todoValues.splice(numHigh, 0, v);
		++numHigh;
		--numLow;
	}
	display(-1, -1);
}

function toMediumPriority(i)
{
	var v = todoValues[i];
	if (i < numHigh) {
		todoValues.splice(i, 1);
		todoValues.splice(numHigh-1, 0, v);
		++numMedium;
		--numHigh;
	}
	else if (i < numHigh+numMedium) {
	}
	else {
		todoValues.splice(i, 1);
		todoValues.splice(numHigh+numMedium, 0, v);
		++numMedium;
		--numLow;
	}
	display(-1, -1);
}

function toLowPriority(i)
{
	var v = todoValues[i];
	if (i < numHigh) {
		todoValues.splice(i, 1);
		todoValues.splice(numHigh+numMedium-1, 0, v);
		++numLow;
		--numHigh;
	}
	else if (i < numHigh+numMedium) {
		todoValues.splice(i, 1);
		todoValues.splice(numHigh+numMedium-1, 0, v);
		++numLow;
		--numMedium;
	}
	else {
	}
	display(-1, -1);
}

function priorityName(i)
{
	if (i < numHigh) {
		return "high";
	}
	else if (i < numHigh + numMedium) {
		return "medium";
	}
	else {
		return "low";
	}
}

function createDoneTodo(i, doneValue)
{
	return "<input type=\"checkbox\" checked name=\"done_"+i+"\" onclick=\"uncheck(this, "+i+")\"/> "+
		escapeHtml(doneValue)+
		" <img onclick=\"return deleteDone("+i+")\" title=\"delete\" width=12 height=12 src=\"images/delete.png\"/>"+"<br/>";
}

function updatePriorityNum(i, direction)
{
	if (i < numHigh) {
		numHigh += direction;
	}
	else if (i < numHigh + numMedium) {
		numMedium += direction;
	}
	else {
		numLow += direction;
	}
}

function check(cb, i)
{
	updatePriorityNum(i, -1);
	v = todoValues[i];
	todoValues.splice(i, 1);
	doneValues.unshift(v);
	document.newtodoform.item.focus();
	display(-1, -1);
}

function uncheck(cb, i)
{
	v = doneValues[i];
	doneValues.splice(i, 1);
	todoValues.splice(numHigh+numMedium, 0, v);
	++numMedium;
	document.newtodoform.item.focus();
	display(-1, -1);
}

function deleteTodo(i)
{
	updatePriorityNum(i, -1);
	todoValues.splice(i, 1);
	document.newtodoform.item.focus();
	editValue=-1;
	display(-1, -1);
	return true;
}

function editTodo(i)
{
	display(i, -1);
	document.todoform.edittodo.value = todoValues[i];
	document.todoform.edittodo.focus();
	return true;
}

function deleteDone(i)
{
	doneValues.splice(i, 1);
	document.newtodoform.item.focus();
	display(-1, -1);
	return true;
}

function upTodo(i)
{
	if (i > 0) {
		v = todoValues[i];
		todoValues.splice(i, 1);
		todoValues.splice(i-1, 0, v);
		updatePriorityNum(i, -1);
		updatePriorityNum(i-1, 1);
		document.newtodoform.item.focus();
		display(-1, -1);
	}
	return true;
}

function downTodo(i)
{
	if (i < todoValues.length-1) {
		v = todoValues[i];
		todoValues.splice(i, 1);
		todoValues.splice(i+1, 0, v);
		updatePriorityNum(i+1, 1);
		updatePriorityNum(i, -1);
		document.newtodoform.item.focus();
		display(-1, -1);
	}
	return true;
}

function display(editIndex, editPriorityIndex) {
	editValue = editIndex;
	editPriorityValue = editPriorityIndex;

	document.getElementById('todoitems').innerHTML="";
	for (i=0; i < todoValues.length; ++i) {
		document.getElementById('todoitems').innerHTML+=createTodo(i, todoValues[i]);
	}
	document.getElementById('doneitems').innerHTML="";
	for (i=0; i < doneValues.length; ++i) {
		document.getElementById('doneitems').innerHTML+=createDoneTodo(i, doneValues[i]);
	}
	save();
}

function saveValues(key, list)
{
	widget.setPreferenceForKey(""+list.length, "num"+key);
	for (i=0; i < list.length; ++i) {
		widget.setPreferenceForKey(list[i], key+"_"+i);
	}
}

function save()
{
	saveValues("Todo", todoValues);
	saveValues("Done", doneValues);
	widget.setPreferenceForKey(numHigh, "numHigh");
	widget.setPreferenceForKey(numLow, "numLow");
}

function loadValues(key, list)
{	
	var num = loadInt("num"+key, 0);
	for (i=0; i<num; ++i) {
		list.push(widget.preferenceForKey(key+"_"+i));
	}
}

function loadInt(name, defaultVal)
{
	var num = widget.preferenceForKey(name);
	if (num == "") {
		num = defaultVal;
	} else {
		num = parseInt(num);
	}
	return num;
}

function load()
{
	loadValues("Todo", todoValues);
	loadValues("Done", doneValues);

	fs = widget.preferenceForKey("pref-fontsize");
	if (fs == "small") {
		document.getElementById('fontsize').selectedIndex = 1;
	} else {
		document.getElementById('fontsize').selectedIndex = 0;
	}
	onFontSizeChanged();

	sz = widget.preferenceForKey("pref-widgetsize");
	if (sz == "extended") {
		document.getElementById('widgetsize').selectedIndex = 2;
	} else if (sz == "compact" || sz == "") {
		document.getElementById('widgetsize').selectedIndex = 1;
	} else {
		document.getElementById('widgetsize').selectedIndex = 0;
	}
	onWidgetSizeChanged();

	numHigh = loadInt("numHigh", 0);
	numLow = loadInt("numLow", 0);
	numMedium = todoValues.length - numHigh - numLow;
	display(-1, -1);
}

function onFontSizeChanged() 
{
	if (document.getElementById('fontsize').selectedIndex == 0) {
		document.getElementById('scrollcontent').style.fontSize = "medium";
	}
	else {
		document.getElementById('scrollcontent').style.fontSize = "small";
	}
	widget.setPreferenceForKey(document.getElementById('scrollcontent').style.fontSize, "pref-fontsize");
}

function onWidgetSizeChanged() 
{
	var diff = 0;
	if (document.getElementById('widgetsize').selectedIndex == 0) {
		document.body.style.backgroundImage= 'url(images/bgmin.png)';
		widget.setPreferenceForKey("minimal", "pref-widgetsize");
	}
	else if (document.getElementById('widgetsize').selectedIndex == 1) {
		document.body.style.backgroundImage= 'url(images/bg.png)';
		widget.setPreferenceForKey("compact", "pref-widgetsize");
		diff = 118;
	}
	else {
		document.body.style.backgroundImage= 'url(images/bgext.png)';
		widget.setPreferenceForKey("extended", "pref-widgetsize");
		diff = 265;
	}
	document.body.style.height = 152 + diff;
	document.getElementById('configcontent').style.height = 32 + diff;
	document.getElementById('scrollcontent').style.height = 32 + diff;
	document.getElementById('flipfront').style.bottom = 295 - diff;
	document.getElementById('flipback').style.bottom = 295 - diff;
}

function escapeQuote(s)
{
	s = s.replace(/"/g,"\\\"");
	return s;
}

function escapeHtml(s) 
{
	s = s.replace(/&/g,"&amp;");
	s = s.replace(/</g,"&lt;");
	s = s.replace(/>/g,"&gt;");
	return s;
}
